"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "DIRECTIONS", {
  enumerable: true,
  get: function get() {
    return _constants.DIRECTIONS;
  }
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _react = _interopRequireDefault(require("react"));
var _brcast = _interopRequireDefault(require("brcast"));
var _brcast2 = _interopRequireDefault(require("./proptypes/brcast"));
var _direction = _interopRequireDefault(require("./proptypes/direction"));
var _constants = require("./constants");
/* eslint-disable react/require-default-props */
// This component provides a string to React context that is consumed by the
// withDirection higher-order component. We can use this to give access to
// the current layout direction for components to use.

var propTypes = {
  children: _propTypes["default"].node.isRequired,
  direction: _direction["default"].isRequired,
  inline: _propTypes["default"].bool,
  lang: _propTypes["default"].string
};
var defaultProps = {
  inline: false
};
var childContextTypes = (0, _defineProperty2["default"])({}, _constants.CHANNEL, _brcast2["default"]);
var DirectionProvider = exports["default"] = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2["default"])(DirectionProvider, _React$Component);
  function DirectionProvider(props) {
    var _this;
    _this = _React$Component.call(this, props) || this;
    _this.broadcast = (0, _brcast["default"])(props.direction);
    return _this;
  }
  var _proto = DirectionProvider.prototype;
  _proto.getChildContext = function getChildContext() {
    return (0, _defineProperty2["default"])({}, _constants.CHANNEL, this.broadcast);
  };
  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (this.props.direction !== nextProps.direction) {
      this.broadcast.setState(nextProps.direction);
    }
  };
  _proto.render = function render() {
    var _this$props = this.props,
      children = _this$props.children,
      direction = _this$props.direction,
      inline = _this$props.inline,
      lang = _this$props.lang;
    var Tag = inline ? 'span' : 'div';
    return /*#__PURE__*/_react["default"].createElement(Tag, (0, _extends2["default"])({
      dir: direction
    }, lang && {
      lang: lang
    }), _react["default"].Children.only(children));
  };
  return DirectionProvider;
}(_react["default"].Component);
DirectionProvider.propTypes = propTypes;
DirectionProvider.defaultProps = defaultProps;
DirectionProvider.childContextTypes = childContextTypes;