"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CSS = void 0;
exports.cleanupCompilationEnvironment = cleanupCompilationEnvironment;
exports.getCSS = getCSS;
exports.prepareCompilationEnvironment = prepareCompilationEnvironment;
exports.resetCSS = resetCSS;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _jsdom = require("jsdom");
var _object = _interopRequireDefault(require("object.values"));
var _object2 = _interopRequireDefault(require("object.entries"));
var _globalCache = _interopRequireDefault(require("global-cache"));
var _interface = _interopRequireDefault(require("../interface"));
var _constants = require("../interface/utils/constants");
var _getClassName = _interopRequireDefault(require("../interface/utils/getClassName"));
var _noImportant = require("../../reactWithStylesInterfaceAphrodite/no-important");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; } /* eslint-disable import/order */ /* eslint-disable import/no-extraneous-dependencies */ /* eslint-disable import/named */
// eslint-disable-next-line import/no-mutable-exports
var CSS = exports.CSS = '';
var ReactDOM;
var ReactDOMServer;
var hasReactDOM = false;
try {
  ReactDOM = require('react-dom'); // eslint-disable-line global-require
  ReactDOMServer = require('react-dom/server'); // eslint-disable-line global-require
  hasReactDOM = true;
} catch (err) {} // eslint-disable-line no-empty

var oldWindow;
var oldDocument;
var oldReactDOMRender;
var oldCSSInterfaceCreate;
function resetCSS() {
  exports.CSS = CSS = '';
}
function getCSS(stylesObject) {
  var sharedState = _globalCache["default"].get(_constants.GLOBAL_CACHE_KEY) || {};
  var _sharedState$namespac = sharedState.namespace,
    namespace = _sharedState$namespac === void 0 ? '' : _sharedState$namespac,
    _sharedState$maxSpeci = sharedState.maxSpecificity,
    maxSpecificity = _sharedState$maxSpeci === void 0 ? _constants.MAX_SPECIFICITY : _sharedState$maxSpeci;
  var stylesObjectWithSpecificity = _objectSpread({}, stylesObject);
  (0, _object2["default"])(stylesObject).forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
      styleName = _ref2[0],
      styleDef = _ref2[1];
    var _loop = function _loop(i) {
      var repeatedSpecifier = Array.from({
        length: i
      }, function () {
        return "".concat(styleName, "_").concat(i);
      }).join('.');
      stylesObjectWithSpecificity[repeatedSpecifier] = styleDef;
    };
    for (var i = 1; i <= maxSpecificity; i += 1) {
      _loop(i);
    }
  });
  var styleSheet = _noImportant.StyleSheet.create(stylesObjectWithSpecificity);
  (0, _object2["default"])(styleSheet).forEach(function (_ref3) {
    var _ref4 = (0, _slicedToArray2["default"])(_ref3, 2),
      styleName = _ref4[0],
      styleSheetObject = _ref4[1];
    // getClassName removes the aphrodite hash, creating a clean classname
    // eslint-disable-next-line no-underscore-dangle, no-param-reassign
    styleSheetObject._name = (0, _getClassName["default"])(namespace, styleName);
  });
  var _StyleSheetServer$ren = _noImportant.StyleSheetServer.renderStatic(function () {
      (0, _object["default"])(styleSheet).forEach(function (style) {
        (0, _noImportant.css)(style);
      });
    }),
    CSSInfo = _StyleSheetServer$ren.css;
  var newCSS = CSSInfo.content;

  // Prepend newCSS so the entry point styles appear at the top of the stylesheet
  exports.CSS = CSS = newCSS + CSS;
  return {};
}
function prepareCompilationEnvironment() {
  var _JSDOM = new _jsdom.JSDOM(),
    jsdomWindow = _JSDOM.window;
  var jsdomDocument = jsdomWindow.document;
  oldWindow = global.window;
  global.window = jsdomWindow;
  oldDocument = global.document;
  global.document = jsdomDocument;
  if (hasReactDOM) {
    oldReactDOMRender = ReactDOM.render;
    ReactDOM.render = ReactDOMServer.renderToString;
  }
  oldCSSInterfaceCreate = _interface["default"].create;
  _interface["default"].create = getCSS;
}
function cleanupCompilationEnvironment() {
  global.window = oldWindow;
  global.document = oldDocument;
  if (hasReactDOM) ReactDOM.render = oldReactDOMRender;
  _interface["default"].create = oldCSSInterfaceCreate;
}